﻿using System;
using System.Collections;
using System.Collections.Generic;
using HeuristicLab.Persistence.Interfaces;

namespace HeuristicLab.Persistence.Default.Decomposers {
  
  public class KeyValuePairDecomposer : IDecomposer {    

    public bool CanDecompose(Type type) {
      return type.IsGenericType &&
             type.GetGenericTypeDefinition() == 
             typeof (KeyValuePair<int, int>).GetGenericTypeDefinition();
    }

    public IEnumerable DeCompose(object o) {      
      Type t = o.GetType();
      yield return t.GetProperty("Key").GetValue(o, null);
      yield return t.GetProperty("Value").GetValue(o, null);
    }

    public object Compose(IEnumerable o, Type t) {      
      return Activator.CreateInstance(t,
        new List<object>((IEnumerable<object>)o).ToArray());
    }    
  }

}
