﻿using System;

namespace HeuristicLab.Persistence.Default.Xml.Compact {

  public class DoubleArray2XmlFormatter : NumberArray2XmlFormatter {

    public override Type Type {
      get {
        return typeof(double[]);
      }
    }

    protected override string formatValue(object o) {
      return ((double)o).ToString("r");
    }

    protected override object parseValue(string o) {
      return double.Parse(o);
    }
  }


  public class Double2DArray2XmlFormatter : DoubleArray2XmlFormatter {
    public override Type Type {
      get {
        return typeof(double[,]);
      }
    }
  }


  public class Double3DArray2XmlFormatter : DoubleArray2XmlFormatter {
    public override Type Type {
      get {
        return typeof(double[, ,]);
      }
    }
  }
  
}